/**
 * This package implements a limited flow-sensitive analysis for annotated 
 * types.
 * 
 * <p>
 * 
 * Work is underway to separate this package and its functionality from the
 * {@link checkers.quals.NonNull} checker to create a generalized flow-sensitive 
 * analysis that any checker can use.
 * 
 * @manual #implicit-nonnull Implicit non-null types
 */
package checkers.nonnull.flow;