import checkers.quals.Interned;

import java.util.*;

public class Arrays {

  public static Integer[] arrayclone_simple(Integer[] a_old) {
    int len = a_old.length;
    Integer[] a_new = new Integer[len];
    for (int i = 0; i < len; i++) {
      a_new[i] = new Integer(a_old[i]); // valid
    }
    return a_new;
  }

  public static void test(@Interned Integer i, @Interned String s) {
    @Interned String[] iarray1 = new @Interned String[2];
    @Interned String[] iarray2 = new @Interned String[] {"foo", "bar"};
    s = iarray1[1];             // error

    String[] sa;
    sa = iarray1;               // OK
    iarray1 = sa;               // error

    String[@Interned] istrings1 = new String[@Interned 2];
    String[@Interned] istrings2 = new String[@Interned] {"foo", "bar"};
    s = istrings1[1];           // OK
  }

  public final /*@Interned*/ class Foo { }

  private static Foo[] returnToArray() {
    List<Foo> li = new ArrayList<Foo>();
    return li.toArray(new Foo[li.size()]);
  }

}
