import checkers.quals.*;
import java.util.*;

public class DefaultAnnotation {

    public void testNoDefault() {
        
        String s = null;

    }

    @Default(value="checkers.quals.NonNull", types={DefaultLocation.ALL})
    public void testDefault() {

        String s = null;                                // error
        List<String> lst = new LinkedList<String>();    // valid
        lst.add(null);                                  // error
    }

    @Default(value="checkers.quals.NonNull", types={DefaultLocation.ALL})
    public class InnerDefault {

        public void testDefault() {
            String s = null;                                // error
            List<String> lst = new LinkedList<String>();    // valid
            lst.add(null);                                  // error
            s = lst.get(0);                                 // valid

            List<@Nullable String> nullList 
                = new LinkedList<@Nullable String>();       // valid
            nullList.add(null);                             // valid
            s = nullList.get(0);                            // error
        }

    }

}
