import checkers.quals.*;

@ReadOnly class RoClass {

    public RoClass() @ReadOnly {} // readonly constructor
    public RoClass(String s) {}   // "mutable" constructor

    String x;          // this-mutable resolves as readonly
    static String sx;  // readonly

    public void testConstructors() {
        RoClass a = new RoClass();   // error
        @ReadOnly RoClass b = new RoClass();
        a = new RoClass("");         // error
        b = new RoClass("");
    }

    public void testFieldsPseudoMutable() {
        @Mutable String a = "a";
        a = x;      // error
        a = sx;     // error
        sx = x;     // error
        x = sx;     // error
    }

    public void testFieldsReadOnly() @ReadOnly {
        @Mutable String a = "a";
        a = x;      // error
        a = sx;     // error
        sx = x;     // error
        x = sx;     // error
    }

}
